/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VSquareLimitRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VSquareLimit extends TableImpl<VSquareLimitRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_square_limit</code>
     */
    public static final VSquareLimit V_SQUARE_LIMIT = new VSquareLimit();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VSquareLimitRecord> getRecordType() {
        return VSquareLimitRecord.class;
    }

    /**
     * The column <code>common_dd.v_square_limit.dn</code>.
     */
    public final TableField<VSquareLimitRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_square_limit.limit_hard_up</code>.
     */
    public final TableField<VSquareLimitRecord, String> LIMIT_HARD_UP = createField(DSL.name("limit_hard_up"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_square_limit.limit_hard_low</code>.
     */
    public final TableField<VSquareLimitRecord, String> LIMIT_HARD_LOW = createField(DSL.name("limit_hard_low"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_square_limit.limit_soft_up</code>.
     */
    public final TableField<VSquareLimitRecord, String> LIMIT_SOFT_UP = createField(DSL.name("limit_soft_up"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_square_limit.limit_soft_low</code>.
     */
    public final TableField<VSquareLimitRecord, String> LIMIT_SOFT_LOW = createField(DSL.name("limit_soft_low"), SQLDataType.CLOB, this, "");

    private VSquareLimit(Name alias, Table<VSquareLimitRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VSquareLimit(Name alias, Table<VSquareLimitRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_square_limit" as  WITH x(dn) AS (
                SELECT h.dn
                  FROM (common_dd.t_core_variable v
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
               ), xhu(dn, l) AS (
                SELECT h.dn,
                   (c.logiccond_comparator || (c.logiccond_value)::text) AS "?column?"
                  FROM ((((common_dd.t_core_variable v
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
                    LEFT JOIN common_dd.t_core_logic l ON (((l.fk_variable = v.key_variable) AND (l.fk_logictype = 2))))
                    LEFT JOIN common_dd.t_core_logicandgrp a ON ((a.fk_orgrp = l.fk_orgrp)))
                    LEFT JOIN common_dd.t_core_logiccond c ON (((c.fk_andgrp = a.andgrp) AND (c.logiccond_comparator = ANY (ARRAY['>'::text, '>='::text])))))
               ), xhd(dn, l) AS (
                SELECT h.dn,
                   (c.logiccond_comparator || (c.logiccond_value)::text) AS "?column?"
                  FROM ((((common_dd.t_core_variable v
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
                    LEFT JOIN common_dd.t_core_logic l ON (((l.fk_variable = v.key_variable) AND (l.fk_logictype = 2))))
                    LEFT JOIN common_dd.t_core_logicandgrp a ON ((a.fk_orgrp = l.fk_orgrp)))
                    LEFT JOIN common_dd.t_core_logiccond c ON (((c.fk_andgrp = a.andgrp) AND (c.logiccond_comparator = ANY (ARRAY['<'::text, '<='::text])))))
               ), xsu(dn, l) AS (
                SELECT h.dn,
                   (c.logiccond_comparator || (c.logiccond_value)::text) AS "?column?"
                  FROM ((((common_dd.t_core_variable v
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
                    LEFT JOIN common_dd.t_core_logic l ON (((l.fk_variable = v.key_variable) AND (l.fk_logictype = 3))))
                    LEFT JOIN common_dd.t_core_logicandgrp a ON ((a.fk_orgrp = l.fk_orgrp)))
                    LEFT JOIN common_dd.t_core_logiccond c ON (((c.fk_andgrp = a.andgrp) AND (c.logiccond_comparator = ANY (ARRAY['>'::text, '>='::text])))))
               ), xsd(dn, l) AS (
                SELECT h.dn,
                   (c.logiccond_comparator || (c.logiccond_value)::text) AS "?column?"
                  FROM ((((common_dd.t_core_variable v
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
                    LEFT JOIN common_dd.t_core_logic l ON (((l.fk_variable = v.key_variable) AND (l.fk_logictype = 3))))
                    LEFT JOIN common_dd.t_core_logicandgrp a ON ((a.fk_orgrp = l.fk_orgrp)))
                    LEFT JOIN common_dd.t_core_logiccond c ON (((c.fk_andgrp = a.andgrp) AND (c.logiccond_comparator = ANY (ARRAY['<'::text, '<='::text])))))
               )
        SELECT x.dn,
           xhu.l AS limit_hard_up,
           xhd.l AS limit_hard_low,
           xsu.l AS limit_soft_up,
           xsd.l AS limit_soft_low
          FROM ((((x
            LEFT JOIN xhu ON (((xhu.dn = x.dn) AND (xhu.l IS NOT NULL))))
            LEFT JOIN xhd ON (((xhd.dn = x.dn) AND (xhd.l IS NOT NULL))))
            LEFT JOIN xsu ON (((xsu.dn = x.dn) AND (xsu.l IS NOT NULL))))
            LEFT JOIN xsd ON (((xsd.dn = x.dn) AND (xsd.l IS NOT NULL))))
         WHERE (COALESCE(xhu.l, xhd.l, xsu.l, xsd.l) IS NOT NULL);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_square_limit</code> table reference
     */
    public VSquareLimit(String alias) {
        this(DSL.name(alias), V_SQUARE_LIMIT);
    }

    /**
     * Create an aliased <code>common_dd.v_square_limit</code> table reference
     */
    public VSquareLimit(Name alias) {
        this(alias, V_SQUARE_LIMIT);
    }

    /**
     * Create a <code>common_dd.v_square_limit</code> table reference
     */
    public VSquareLimit() {
        this(DSL.name("v_square_limit"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VSquareLimit as(String alias) {
        return new VSquareLimit(DSL.name(alias), this);
    }

    @Override
    public VSquareLimit as(Name alias) {
        return new VSquareLimit(alias, this);
    }

    @Override
    public VSquareLimit as(Table<?> alias) {
        return new VSquareLimit(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VSquareLimit rename(String name) {
        return new VSquareLimit(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VSquareLimit rename(Name name) {
        return new VSquareLimit(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VSquareLimit rename(Table<?> name) {
        return new VSquareLimit(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit where(Condition condition) {
        return new VSquareLimit(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSquareLimit where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSquareLimit where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSquareLimit where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VSquareLimit where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VSquareLimit whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
